<template>
    <div>
        <div class="box-table-element" v-for="promo in promos">
            <p class="name-blue">{{ promo.name }}</p>
            <p class="b-v">{{ $t('promos.pages.table.invested') }} <span>$ {{ promo.invested | formatAmount }}</span></p>
            <p class="text-grey-opacity">{{ $t('promos.pages.table.income') }} <span>$ {{ promo.income | formatAmount }}</span></p>
            <profit-help>
                <span :class="{'color-green' : promo.profit >= 0}">$ {{ promo.profit | formatAmount }} ( % {{ Number.parseFloat(promo.profit_percent).toFixed(2) }})</span>
            </profit-help>
            <p class="text-grey-opacity">{{ $t('promos.pages.table.structure') }} {{ promo.structure }} {{ $t('ui.people') }}</p>
			<div class="box-icon">
                <svg class="blue">
                    <use :xlink:href="`/img/sprite.svg#${promoIcon(promo)}`"></use>
                </svg>
            </div>
        </div>
        <paginator
            :current-page="currentPage"
            :last-page="lastPage"
            :per-page="perPage"
            :items-count="total"
            @page-changed="setPage"
        />
    </div>
</template>

<script>
	import {mapGetters} from "vuex";
    import ProfitHelp from "./ProfitHelp";
	import currencies from "../../currencies";

    export default {
		name: "AllPromosTable",
        props: ['filter'],
        data(){
            return {
                currentPage: 0,
                lastPage: 0,
                perPage: 0,
                total: 0,
                page: 1,
                promos: [],
            }
        },
		filters: {
			formatAmount(value){
				return currencies.formatAmount(value);
			}
		},
        computed: {
            ...mapGetters([
                'axios'
            ])
        },
        watch: {
            filter(){
                this.submit();
            },
        },
        methods: {
            submit(){
                this.axios
                    .get('promos', {
                        params: {
                            type: this.filter,
                            page: this.page
                        }
                    })
                    .then(resp => resp.data)
                    .then(promos => {
                        console.log(promos);
                        this.currentPage = promos.current_page;
                        this.lastPage = promos.last_page;
                        this.perPage = promos.per_page;
                        this.total = promos.total;
                        this.promos = promos.data;
                    });
            },
            formatDate(date){
                return this.$date(date).format('DD.MM.YYYY');
            },
            promoIcon(promo){
                switch (promo.type) {
                    case 'monitoring':
                        return 'pc';
                    case 'blog':
                        return 'pencil2';
                    case 'banner':
                        return 'ribbon';
                    case 'video':
                        return 'youtube00';
                }
            },
            setPage(page){
                this.page = page;
                this.submit();
            },
        },
        components: {
            ProfitHelp
        },
        created(){
            this.submit();
        }
	}
</script>

<style scoped>
.box-table-element .box-info-profit .profit span.color-green{
	color: #3cc32f;
}
</style>
